<?php
namespace Util\Instance;

use Zeedhi\Framework\DependencyInjection\InstanceManager;

class Service {
    /** @return  Service */
    public static function getInstance()
    {
        return new static();
    }

    /** @return  \Service\Resource */
    public static function getResource()
    {
        return InstanceManager::getInstance()->getService('\Service\Resource');
    }

    /** @return  \Service\ErrorClassification */
    public function getErrorClassification()
    {
        return InstanceManager::getInstance()->getService('\Service\ErrorClassification');
    }

    /** @return  \Service\Queue\Task\Consumer */
    public function getQueueTaskConsumer()
    {
        return InstanceManager::getInstance()->getService('\Service\Queue\Task\Consumer');
    }

    /** @return  \Service\ZhUserAllocation */
    public function getZhUserAllocation()
    {
        return InstanceManager::getInstance()->getService('\Service\ZhUserAllocation');
    }

    /** @return  \Service\ProjectRelationship */
    public function getProjectRelationship()
    {
        return InstanceManager::getInstance()->getService('\Service\ProjectRelationship');
    }

    /** @return  \Service\Calendar */
    public function getCalendar()
    {
        return InstanceManager::getInstance()->getService('\Service\Calendar');
    }

    /** @return  \Service\Permission */
    public function getPermission()
    {
        return InstanceManager::getInstance()->getService('\Service\Permission');
    }

    /** @return  \Service\Allocation */
    public function getAllocation()
    {
        return InstanceManager::getInstance()->getService('\Service\Allocation');
    }

    /** @return  \Service\TaskTypeClassification */
    public function getTaskTypeClassification()
    {
        return InstanceManager::getInstance()->getService('\Service\TaskTypeClassification');
    }

    /** @return  \Service\Appropriation */
    public static function getAppropriation()
    {
        return InstanceManager::getInstance()->getService('\Service\Appropriation');
    }

    /** @return  \Service\TaskPrecursor */
    public function getTaskPrecursor()
    {
        return InstanceManager::getInstance()->getService('\Service\TaskPrecursor');
    }

    /** @return  \Service\Calendar\TaskCalendar */
    public function getCalendarTakCalendar()
    {
        return InstanceManager::getInstance()->getService('\Service\Calendar\TaskCalendar');
    }

    /** @return  \Service\Repository */
    public function getRepository()
    {
        return InstanceManager::getInstance()->getService('\Service\Repository');
    }

    /** @return  \Service\ResourceProject */
    public function getResourceProject()
    {
        return InstanceManager::getInstance()->getService('\Service\ResourceProject');
    }

    /** @return  \Service\StructureType */
    public function getStructureType()
    {
        return InstanceManager::getInstance()->getService('\Service\StructureType');
    }

    /** @return  \Service\Structure */
    public function getStructure()
    {
        return InstanceManager::getInstance()->getService('\Service\Structure');
    }

    /** @return  \Service\Comment */
    public function getComment()
    {
        return InstanceManager::getInstance()->getService('\Service\Comment');
    }

    /** @return  \Service\Budget */
    public function getBudget()
    {
        return InstanceManager::getInstance()->getService('\Service\Budget');
    }

    /** @return  \Service\ReplanningReason */
    public function getReplanningReason()
    {
        return InstanceManager::getInstance()->getService('\Service\ReplanningReason');
    }

    /** @return  \Service\TaskReplanningReason */
    public function getTaskReplanningReason()
    {
        return InstanceManager::getInstance()->getService('\Service\TaskReplanningReason');
    }

    /** @return  \Service\Task */
    public static function getTask()
    {
        return InstanceManager::getInstance()->getService('\Service\Task');
    }

    /** @return  \Service\Issue */
    public static function getIssue()
    {
        return InstanceManager::getInstance()->getService('\Service\Issue');
    }

    /** @return  \Service\ProjectType */
    public static function getProjectType()
    {
        return InstanceManager::getInstance()->getService('\Service\ProjectType');
    }

     /** @return  \Service\Project */
    public static function getProject()
    {
        return InstanceManager::getInstance()->getService('\Service\Project');
    }

    /** @return  \Service\Classification */
    public function getClassification()
    {
        return InstanceManager::getInstance()->getService('\Service\Classification');
    }

     /** @return  \Service\DocumentTemplate */
    public static function getDocumentTemplate()
    {
        return InstanceManager::getInstance()->getService('\Service\DocumentTemplate');
    }

     /** @return  \Service\Attachment */
    public static function getAttachment()
    {
        return InstanceManager::getInstance()->getService('\Service\Attachment');
    }

    /** @return  \Service\ProductVersion */
    public static function getProductVersion()
    {
        return InstanceManager::getInstance()->getService('\Service\ProductVersion');
    }

    /** @return  \Service\Label*/
    public static function getLabel()
    {
        return InstanceManager::getInstance()->getService('\Service\Label');
    }

    /** @return  \Service\Integration\INTRANETIntegration*/
    public static function getINTRANETIntegration()
    {
        return InstanceManager::getInstance()->getService('\Service\Integration\INTRANETIntegration');
    }

    /** @return  \Service\Teknisa\NewCode */
    public static function getTeknisaNewCode()
    {
        return InstanceManager::getInstance()->getService('\Service\Teknisa\NewCode');
    }
}
