import { Metadata, Http } from '@zeedhi/core';
import { ITabsBeforeChangeEventParam, Form, Modal, ModalService, LoadingService } from '@zeedhi/common';
// import { TekGrid } from '@zeedhi/teknisa-components-vuetify';
import { DialogServiceCustom } from '@/services/DialogServiceCustom';
import { IterableComponentRender } from '@zeedhi/teknisa-components-common';
// import { FileUpload } from '@/services/FileUpload';

export class DemandManagementController {
	public baseUrl = '';

	public callDescription = '';

	public callType = '';

	public callRelationship = '';

	public showDemandManagementForm = false;

    get isVisibleDemandManagementGrid() {
		return !this.showDemandManagementForm;
    }

	private modalAddCall!: Modal;

	private typeIsIAdd = false;

	private typeIsSAdd = false;

	private typeIsIEdit = false;

	private typeIsSEdit = false;

	private modalAddComments!: Modal;

	private modalUploadFile!: Modal;

	public onMountedGeneralCard() {
		this.baseUrl = process.env.VUE_APP_END_POINT;
		console.log(this.baseUrl);
	}

	public async onMountedDemandManagementGrid() {
		this.modalAddCall = await ModalService.createFromJson('demandManagement/modal/addCallDemandManagementModal', true);
	}

	public onDestroyDemandManagementGrid() {
		this.modalAddCall?.destroy();
	}

	public addButtonDemandManagementGrid() {
		this.modalAddCall.show();
	}

	public closeAddModalDemandManagementGrid() {
		this.modalAddCall.hide();
		this.typeIsIAdd = false;
		this.typeIsSAdd = false;
	}

	// START MODAL ADD CALL ----
	public onInputProductAddCallModal(params: any) {
		console.log(params);
		if (params.value) {
			if (params.value === 'I') {
				this.typeIsIAdd = true;
				this.typeIsSAdd = false;
			} else {
				this.typeIsIAdd = false;
				this.typeIsSAdd = true;
			}
		}
	}
	// END MODAL ADD CALL ----

	// START CALL GRID ---
	public async rowClickGridDemandManagement(params: any) {
		LoadingService.show('Carregando');
		this.showDemandManagementForm = true;
		this.callDescription = params.row.REFERENCE;
		this.callType = params.row.TYPE;
		if (params.row.TYPE === 'I') {
			this.typeIsIEdit = true;
			this.typeIsSEdit = false;
		} else {
			this.typeIsIEdit = false;
			this.typeIsSEdit = true;
		}
		this.callRelationship = params.row.CALL_RELATIONSHIP;
		await this.fillCallForm();
		LoadingService.hide();
		// const callFormInstance = Metadata.getInstance<Form>('formDemandManagement');
		// console.log(callFormInstance);
	}

	public async fillCallForm() {
		const sendObject = { params: {
				CALL_RELATIONSHIP: this.callRelationship,
				CALL_TYPE: this.callType,
			},
		};
		const callFormInstance = Metadata.getInstance<Form>('formDemandManagement');
		console.log('callFormInstance');
		console.log(callFormInstance);
		const callData = await Http.get('call', sendObject);
		console.log(callData);
		callFormInstance.value.clientIdEdit = callData.data.data.ID; // I S
		callFormInstance.value.teknisaIdEdit = callData.data.data.CALL_RELATIONSHIP; // I S
		callFormInstance.value.reportedByEdit = callData.data.data.REPORTER_NAME; // I S
		callFormInstance.value.referenceEdit = callData.data.data.REFERENCE; // I S
		callFormInstance.value.productEdit = callData.data.data.PRODUCT; // I S
		callFormInstance.value.productTypeEdit = callData.data.data.PRODUCT_TYPE_NAME; // S
		callFormInstance.value.screenNameEdit = callData.data.data.MENU_ITEM_ID; // I
		callFormInstance.value.versionEdit = callData.data.data.MENU_VERSION; // I S
		callFormInstance.value.devVersionEdit = callData.data.data.VERSION_DEV;
		callFormInstance.value.categoryEdit = callData.data.data.CLASSIFICATION;
		// callFormInstance.value.rotulesEdit = callData.data.
		callFormInstance.value.clientEdit = callData.data.data.NMRAZSOCCLIE;
		callFormInstance.value.descriptionEdit = callData.data.data.DESCRIPTION;

		// Requisição de categoria: findProductCallClassification
	}
	// END CALL GRID -----

	// START CALL TAB ----
	public editCallButton() {
		console.log('alo');
	}

	public clickBackCardFormDemandManagement() {
		const tabsInstance = Metadata.getInstance<ITabsBeforeChangeEventParam>('tabMainFormDemandManagement');
		tabsInstance.activeTab = 0;
		this.showDemandManagementForm = false;
	}

	public clickProductOnForm() {
		console.log('click product');
		// Da um get em findProductCallProducts
	}

	public changeProductOnForm(params: any) {
		if (params.value) {
			// Da um get em findMenuItems
			// Da um get em findProductVersion
			console.log('change product');
			console.log(params);
		}
	}

	public changeScreenNameOnForm(params: any) {
		if (params.value) {
			// Da um get em findProductVersion
			console.log('change screenName');
			console.log(params);
		}
	}
	// END CALL TAB ------

	// START COMMENTS TAB --
	public onCreatedIterableComments(params: any) {
		if (params.component.activeTab === 1) {
			setTimeout(async () => {
				const iterableComments = Metadata.getInstance<IterableComponentRender>('iterableComments');
				iterableComments.datasource.filter.CALL_TYPE = this.callType;
				iterableComments.datasource.filter.CALL_RELATIONSHIP = this.callRelationship;
				try {
					await iterableComments.datasource.get();
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
				}
			}, 1);
		}

		if (params.component.activeTab === 2) {
			setTimeout(async () => {
				const gridAttachments = Metadata.getInstance<any>('gridAttachments');
				console.log(gridAttachments);
				gridAttachments.datasource.filter.CALL_TYPE = this.callType;
				gridAttachments.datasource.filter.CALL_RELATIONSHIP = this.callRelationship;
				try {
					await gridAttachments.datasource.get();
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
				}
			}, 1);
		}
	}

	public async onMountedButtonAddComments() {
		this.modalAddComments = await ModalService.createFromJson('demandManagement/modal/addCommentsDemandManagementModal', true);
	}

	public onDestroyButtonAddComments() {
		this.modalAddComments?.destroy();
	}

	public addCommentButton() {
		this.modalAddComments.show();
	}

	public closeAddCommentsModal() {
		this.modalAddComments.hide();
	}

	public clickIterableComments(params: any) {
		console.log(params);
	}

	public onMountedCollapseCardComments(params: any) {
		params.component.readonly = params.component.readonly === 'true';
		params.component.hideAction = params.component.hideAction === 'true';
	}

	public onMountedBuildFileIterableData(params: any) {
		const id = params.component.name.split('-')[1];
		// const collapseCardInstance = Metadata.getInstance<CollapseCard>(`collapseCard-${id}`);
		const iterableCommentsInstance = Metadata.getInstance<IterableComponentRender>('iterableComments');
		const rowData = iterableCommentsInstance.datasource.data.find((row) => row.ID === id);
		if (rowData) {
			if (rowData.ATTACHMENT.length > 0) {
				params.component.datasource.data = rowData.ATTACHMENT;
			}
		}
	}

	public downloadFileComment(params: any) {
		const fileId = params.element.name.split('-')[1];
		const commentId = params.element.name.split('-')[2];
		const fileInstance = Metadata.getInstance<IterableComponentRender>(`iterableFiles-${commentId}`);
		const fileSelected = fileInstance.datasource.data.find((file) => file.ID === fileId);
		if (fileSelected) {
			if (this.callType === 'I') {
				const downloadUri = `${this.baseUrl}/downLoadAttachment?ID=${fileSelected.ID}`;
				window.open(downloadUri);
			} else {
				const downloadUri = `${this.baseUrl}/downLoadAttachmentGEP?FILE_NAME=${fileSelected.FILE_NAME}`;
				window.open(downloadUri);
			}
		}
	}
	// END COMMENTS TAB ----

	// START DOCUMENTS TAB ---
	public async onMountedGridAttachments() {
		this.modalUploadFile = await ModalService.createFromJson('demandManagement/modal/uploadFileDemandManagementModal', true);
	}

	public onDestroyGridAttachments() {
		this.modalUploadFile.destroy();
	}

	public addClickGridAttachments() {
		this.modalUploadFile.show();
		// const grid = Metadata.getInstance<TekGrid>('gridAttachments');
		// console.log(grid);
	}

	public downloadFileGrid(params: any) {
		if (this.callType === 'I') {
			const downloadUri = `${this.baseUrl}/downLoadAttachment?ID=${params.row.ID}`;
			window.open(downloadUri);
		} else {
			const downloadUri = `${this.baseUrl}/downLoadAttachmentGEP?FILE_NAME=${params.row.FILE_NAME}`;
			window.open(downloadUri);
		}
	}

	public async deleteAttachmentsGrid(params: any) {
		params.event.preventDefault();
		console.log(params.getCu);
		const sendObject = {
			dataset: params.component.selectedRows,
		};
		try {
			await Http.post('remove', sendObject);
		} catch (e) {
			DialogServiceCustom.showErrorBackend(e);
		}
	}
	// END DOCUMENTS TAB -----

	// START DOCUMENTS MODAL ---
	public async saveUploadFileModal() {
		// this.saveLoadingModal = true;
        // this.noFileSelected = true;
        // const fileInput: any = Metadata.getInstance('fileInput-UploadFileDemandManagementModal');
        // const sendObject = await FileUpload.buildFileSendObject(fileInput.value[0]);
        // console.log(sendObject);
        // if (fileInput.value[0].type === 'application/pdf' && fileInput.value[0].size < 50000000) {
        //     try {
        //         const newDocSrc = await Http.post('/callAttachments/save', {
        //             dataset: [
        //                 {
        //                     UPLOAD_PRIVACY_POLICY:
        //                     [
        //                         sendObject,
        //                     ],
        //                 },
        //             ],
        //             requestType: 'DataSet',
        //         });
        //         this.docSrc = newDocSrc.data[0].pdfPath;
        //         await this.setDocSrc();
        //         this.denieDeleteButton = newDocSrc.data[0].documentDefault;
        //         this.modalPrivacyPolicy.hide();
        //     } catch (e) {
        //         LoginDialogService.showErrorBackend(e);
        //         this.noFileSelected = false;
        //     }
        //     LoginAlertService.defaultSaveSuccessAlert();
        //     this.saveLoadingModal = false;
        // } else {
        //     LoginAlertService.customErrorAlert(Messages.ERROR_PDF);
        //     this.saveLoadingModal = false;
        //     this.noFileSelected = false;
        // }
	}

	public closeUploadFileModal() {
		this.modalUploadFile.hide();
	}
	// END DOCUMENTS MODAL -----
}
