import { Interceptor } from '@zeedhi/core';
import Vue from 'vue';
import App from './App.vue';
import router from './router';
import { vuetify } from './plugins';
import store from './store';
import './components';
import './registerServiceWorker';
import 'roboto-fontface/css/roboto/roboto-fontface.css';
import './styles/style.scss';

Vue.config.productionTip = false;

new Vue({
  router,
  vuetify,
  store,
  render: (h) => h(App),
}).$mount('#app');

Interceptor.addRequestSuccess((config) => {
  const token = localStorage.getItem('APP_LOGIN_TOKEN');
  const hash = localStorage.getItem('APP_LOGIN_HASH');
  const productId = localStorage.getItem('APP_LOGIN_PRODUCT_ID');
  if (token) {
      config.headers['OAuth-Token'] = JSON.parse(token);
  }
  if (hash) {
      config.headers['OAuth-Hash'] = JSON.parse(hash);
  }
  if (productId) {
      config.headers['OAuth-Project'] = JSON.parse(productId);
  }
  config.headers['OAuth-KeepConnected'] = 'Yes';
  return config;
});
