import Vue from 'vue';
import Vuex from 'vuex';

Vue.use(Vuex);

export default new Vuex.Store({
  state: {
    routerParams: {},
    appLoginToken: '',
    appLoginHash: '',
    appLoginProductId: '',
    appShowMenu: true,
    appShowHeader: true,
  },
  mutations: {
    setRouterParams: (state, value: any) => {
      state.routerParams = value;
      localStorage.setItem('routeParams', JSON.stringify(value));
    },
    setAppLoginToken: (state, token: string) => {
      state.appLoginToken = token;
    },
    setAppLoginHash: (state, hash: string) => {
        state.appLoginHash = hash;
    },
    setaAppProductId: (state, productId: string) => {
        state.appLoginProductId = productId;
    },
    setAppDisplayOptions: (state, options: any) => {
        state.appShowMenu = options.menu !== '0';
        state.appShowHeader = options.header !== '0';
    },
  },
  actions: {
  },
  getters: {
    routerParams: (state) => state.routerParams,
  },
});
